
      program plotlog

C     fc plotlog.f /"pgplot-dir"/libpgplot.a -lX11 -lm 

      common /zeropt/slzerox(100),slzeroy(100),isl1(100),isl2(100), 
     +     jsl1(100),jsl2(100),emzerox(100),emzeroy(100),iem1(100), 
     +     iem2(100), jem1(100),jem2(100),nslice
      common /centers/slc(100,9),sly(100,9),islcent(100,9),nslc(100),
     +     emc(100,9),emy(100,9),iemcent(100,9),nemc(100),
     +     dclambda(100,9),cvel(100,9),icvel(100,9)
      common /gaussians/slgcen(100,9),slgsig(100,9),slgamp(100,9),
     +     islgauss(100,9),emgcen(100,9),emgsig(100,9),emgamp(100,9),
     +     iemgauss(100,9),dglambda(100,9),gvel(100,9),igvel(100,9)
      common /profiles/slcpeak(100,9),slpeak(100,9),slc80(100,9),
     +     slw80(100,9),slc50(100,9),slw50(100,9),slc20(100,9),
     +     slw20(100,9),slczero(100,9),slwzero(100,9),slflux(100,9),
     +     islprof(100,9),emcpeak(100,9),empeak(100,9),emc80(100,9),
     +     emw80(100,9),emc50(100,9),emw50(100,9),emc20(100,9),
     +     emw20(100,9),emczero(100,9),emwzero(100,9),emflux(100,9),
     +     iemprof(100,9),vpeak(100,9),v80(100,9),w80(100,9),v50(100,9),
     +     w50(100,9),v20(100,9),w20(100,9),vzero(100,9),wzero(100,9),
     +     ivprof(100,9)

      common /radii/rad0(100,9),radl(100,9),radu(100,9),irad(100,9)
      common /spect/disp(100), lambda0(100)
      common /veloc/dlambda(100)

      character logfile*50, line*80, parse(15)*15
      character text1*31, text2*29, text3*20
      real lambda0(100)

      call clnarg(nargs)
      if(nargs.eq.1)then
         call clargc(1,logfile, ier)
      else if (nargs.eq.0)then
         write(*,'('' Log file: '',$)')
         read(*,'(a)')logfile
      else
         print*,'Too many arguments.'
         stop
      endif
      open(unit=1,file=logfile, status='old')

      iunit=6
      
      ix=0
 100  ix=ix+1
      read(1,'(38x,f7.2,7x,f7.2)',end=200)slzerox(ix),slzeroy(ix)
      read(1,'(28x,i4,x,i4,5x,i4,x,i4,3x)')isl1(ix), isl2(ix), 
     +     jsl1(ix),jsl2(ix)
      read(1,'(38x,f7.2,7x,,f7.2)')emzerox(ix),emzeroy(ix)
      read(1,'(28x,i4,x,i4,5x,i4,x,i4,3x)')iem1(ix), iem2(ix), 
     +     jem1(ix),jem2(ix)
      read(1,'(18x,f8.2,17x,f6.3)')lambda0(ix),disp(ix)

C        write(iunit,'('' Emission Line Image Zero-Point: X0 = '',
C     +       f7.2,2x,''Y0 = '',f7.2)')emzerox(ix),emzeroy(ix)
c        write(iunit,'('' Emission Line Image Slice: '',i4,'':'',
C     +       i4,3x,''(from Zero pt.)'')')jem1(ix),jem2(ix)
C        write(iunit,'('' Slitless Spectrum Zero-Point:   X0 = '',
C     +       f7.2,2x,''Y0 = '',f7.2)')slzerox(ix),slzeroy(ix)
C        write(iunit,'('' Slitless Spectrum  Slice:  '',i4,'':'',
C     +       i4,3x,''(from Zero pt.)'')')jsl1(ix),jsl2(ix)
C        write(iunit,'('' Rest Wavelength: '',f8.2,'' --- '',
C     +       ''Dispersion: '',f6.3)')lambda0(ix),disp(ix)

        read(1,'(a)')line
C        write(iunit,'(a)')line
        read(1,'(a)')line
C        write(iunit,'(a)')line
        read(1,'(a)')line
C        write(iunit,'(a)')line
        read(1,'(a)')line
C        write(iunit,'(a)')line

        do i=1,9
           irad(ix,i)=0
           islcent(ix,i)=0
           iemcent(ix,i)=0
        enddo

C      write(iunit,'(''-------------------------------------------'',
C     +     ''-'')')
C      write(iunit,'(''         Centers           shift    '',
C     +     ''velocity'')')
C      write(iunit,'('' #  Slitless   Em.Line      Ang.      '',
C     +     ''km/s '')')
C      write(iunit,'(''-------------------------------------------'',
C     +     ''-'')')

      i=0
      nslc(ix)=0
      nemc(ix)=0

      read(1,'(a)')line
      do while(line(1:4).ne.'----')
         i=i+1

         call parser(line,' ',parse,5,nparse)

         if(parse(2)(1:3).ne.'---'.and.parse(2)(1:3).ne.'***')then
            slc(ix,i)=amkreal(parse(2))
            islcent(ix,i)=1
            nslc(ix)=nslc(ix)+1
         endif

         rad0(ix,i)=(jem1(ix)+jem2(ix))/2.0
         radl(ix,i)=abs(rad0(ix,i)-jem1(ix))+0.5
         radu(ix,i)=abs(rad0(ix,i)-jem2(ix))+0.5
         irad(ix,i)=1

         if(parse(3)(1:3).ne.'---'.and.parse(3)(1:3).ne.'***')then
            emc(ix,i)=amkreal(parse(3))
            iemcent(ix,i)=1
            nemc(ix)=nemc(ix)+1
         endif

         if(parse(4)(1:3).ne.'---'.and.parse(4)(1:3).ne.'***')
     +        dclambda(ix,i)=amkreal(parse(4))
         if(parse(5)(1:3).ne.'---'.and.parse(5)(1:3).ne.'***')then
            cvel(ix,i)=amkreal(parse(5))
            icvel(ix,i)=1
         else
            icvel(ix,i)=0
         endif

C         if((slc(ix,i).gt.-9.0E9).and.(emc(ix,i).gt.-9.0E9))then
C            write(iunit,'(x,i1,4x,f6.2,4x,f6.2,4x,f6.2,4x,i6)')
C     +           i,slc(ix,i),emc(ix,i),dclambda(ix,i),nint(cvel(ix,i))
C         else if((slc(ix,i).gt.-9.0E9).and.(emc(ix,i).lt.-9.0E9))then
C            write(iunit,'(x,i1,4x,f6.2,7x,''---'',
C     +           7x,''---'',7x,''---'')')i,slc(ix,i)
C         else if((slc(ix,i).lt.-9.0E9).and.(emc(ix,i).gt.-9.0E9))then
C            write(iunit,'(x,i1,7x,''---'',4x,f6.2,
C     +           7x,''---'',7x,''---'')')i,emc(ix,i)
C         endif
         read(1,'(a)')line
      enddo
      
C        write(iunit,'(a)')line
        read(1,'(a)')line
C        write(iunit,'(a)')line
        read(1,'(a)')line
C        write(iunit,'(a)')line
        read(1,'(a)')line
C        write(iunit,'(a)')line

C      write(iunit,'(''------------------------------------------'',
c     +     ''------------------------------------'')')
C      write(iunit,'(''     Slitless Spect. Gaussians   '',
C     +     ''Emiss. Line Image Gaussians   shift '',
C     +     ''velocity'')')
C      write(iunit,'('' #   Center   Sigma   Amplitude   '',
C     +     ''Center   Sigma   Amplitude    Ang.   '',
C     +     ''km/s'')')
C      write(iunit,'(''------------------------------------------'',
C     +     ''------------------------------------'')')

      j=0
      read(1,'(a)')line
      do while(line(1:4).ne.'----')
         j=j+1

         call parser(line,' ',parse,9,nparse)

         if(parse(2)(1:3).ne.'---'.and.parse(2)(1:3).ne.'***')
     +        slgcen(ix,j)=amkreal(parse(2))
         if(parse(3)(1:3).ne.'---'.and.parse(3)(1:3).ne.'***')
     +        slgsig(ix,j)=amkreal(parse(3))
         if(parse(4)(1:3).ne.'---'.and.parse(4)(1:3).ne.'***')then
            slgamp(ix,j)=amkreal(parse(4))
            islgauss(ix,j)=1
         else
            slgamp(ix,j)=0.0
            islgauss(ix,j)=0
         endif
         if(parse(5)(1:3).ne.'---'.and.parse(5)(1:3).ne.'***')
     +        emgcen(ix,j)=amkreal(parse(5))
         if(parse(6)(1:3).ne.'---'.and.parse(6)(1:3).ne.'***')
     +        emgsig(ix,j)=amkreal(parse(6))
         if(parse(7)(1:3).ne.'---'.and.parse(7)(1:3).ne.'***')then
            emgamp(ix,j)=amkreal(parse(7))
            iemgauss(ix,j)=1
         else
            emgamp(ix,j)=0.0
            iemgauss(ix,j)=0
         endif

         if(parse(8)(1:3).ne.'---'.and.parse(8)(1:3).ne.'***')
     +        dglambda(ix,j)=amkreal(parse(8))
         if(parse(9)(1:3).ne.'---'.and.parse(9)(1:3).ne.'***')then
            gvel(ix,j)=amkreal(parse(9))
            igvel(ix,j)=1
         else
            igvel(ix,j)=0
         endif
         ampvalue=slgamp(ix,j)
         if(ampvalue.ge.100.0)then
            write(text1,'(x,i1,2x,f7.2,2x,f6.2,2x,i10)')
     +           j,slgcen(ix,j),slgsig(ix,j),slgamp(ix,j)
         else if(ampvalue.lt.200.0.and.ampvalue.ge.0.2)then
            write(text1,'(x,i1,2x,f7.2,2x,f6.2,2x,f10.3)')
     +           j,slgcen(ix,j),slgsig(ix,j),slgamp(ix,j)
         else if(ampvalue.lt.0.2.and.ampvalue.ge.1.0e-5)then
            write(text1,'(x,i1,2x,f7.2,2x,f6.2,2x,f10.7)')
     +           j,slgcen(ix,j),slgsig(ix,j),slgamp(ix,j)
         else if(ampvalue.lt.1.0e-5.and.ampvalue.ne.0.0)then
            write(text1,'(x,i1,2x,f7.2,2x,f6.2,2x,g10.4)')
     +           j,slgcen(ix,j),slgsig(ix,j),slgamp(ix,j)
         else if(ampvalue.eq.0.0)then
            write(text1,'(x,i1,6x,''---'',5x,''---'',9x,
     +           ''---'')')j
         endif
         ampvalue=emgamp(ix,j)
         if(ampvalue.ge.100.0)then
            write(text2,'(2x,f7.2,2x,f6.2,2x,i10)')
     +           emgcen(ix,j),emgsig(ix,j),emgamp(ix,j)
         else if(ampvalue.lt.200.0.and.ampvalue.ge.0.2)then
            write(text2,'(2x,f7.2,2x,f6.2,2x,f10.3)')
     +           emgcen(ix,j),emgsig(ix,j),emgamp(ix,j)
         else if(ampvalue.lt.0.2.and.ampvalue.ge.1.0e-5)then
            write(text2,'(2x,f7.2,2x,f6.2,2x,f10.7)')
     +           emgcen(ix,j),emgsig(ix,j),emgamp(ix,j)
         else if(ampvalue.lt.1.0e-5.and.ampvalue.ne.0.0)then
            write(text2,'(2x,f7.2,2x,f6.2,2x,g10.4)')
     +           emgcen(ix,j),emgsig(ix,j),emgamp(ix,j)
         else if(ampvalue.eq.0.0)then
            write(text2,'(6x,''---'',5x,''---'',9x,''---'')')
         endif

         if(ampvalue.ne.0.0)then
            write(text3,'(2x,f6.2,2x,i6)')dglambda(ix,j),
     +           nint(gvel(ix,j))
         else
            write(text3,'(5x,''---'',5x,''---'')')
         endif
C         write(iunit,'(a31,a29,a20)')text1,text2,text3
         read(1,'(a)')line
      enddo
      
C      write(iunit,'(''------------------------------------------'',
c     +     ''------------------------------------'')')
C      write(iunit,'(32x,''Profile Analysis'')')
C      write(iunit,'('' #   Flux  Cpeak     Peak    C80   W80    '',
C     +     ''C50   W50    C20   W20    C00   W00'')')
C      write(iunit,'(''------------------------------------------'',
C     +     ''------------------------------------'')')

C         write(iunit,'(a)')line
         read(1,'(a)')line
C         write(iunit,'(a)')line
         read(1,'(a)')line
C         write(iunit,'(a)')line
         read(1,'(a)')line
C         write(iunit,'(a)')line
      i=0

      read(1,'(a)') line
      do while(line(1:4).ne.'----')

         iy=mkint(line(2:3))

         do kk=1,3

         call parser(line,' ',parse,12,nparse)
         if(parse(1)(1:1).eq.'S'.and.parse(1)(2:2).ne.'E')then
            i=mkint(parse(1)(2:3))
            if(parse(2)(1:3).ne.'---'.and.parse(2)(1:3).ne.'***')then
               slflux(ix,i)=amkreal(parse(2))
               islprof(ix,i)=1
            else
               slflux(ix,i)=-100.0
               islprof(ix,i)=0
            endif
            if(parse(3)(1:3).ne.'---'.and.parse(3)(1:3).ne.'***')
     +           slcpeak(ix,i)=amkreal(parse(3))
            if(parse(4)(1:3).ne.'---'.and.parse(4)(1:3).ne.'***')
     +           slpeak(ix,i)=amkreal(parse(4))
            if(parse(5)(1:3).ne.'---'.and.parse(5)(1:3).ne.'***')
     +           slc80(ix,i)=amkreal(parse(5))
            if(parse(6)(1:3).ne.'---'.and.parse(6)(1:3).ne.'***')
     +           slw80(ix,i)=amkreal(parse(6))
            if(parse(7)(1:3).ne.'---'.and.parse(7)(1:3).ne.'***')
     +           slc50(ix,i)=amkreal(parse(7))
            if(parse(8)(1:3).ne.'---'.and.parse(8)(1:3).ne.'***')
     +           slw50(ix,i)=amkreal(parse(8))
            if(parse(9)(1:3).ne.'---'.and.parse(9)(1:3).ne.'***')
     +           slc20(ix,i)=amkreal(parse(9))
            if(parse(10)(1:3).ne.'---'.and.parse(10)(1:3).ne.'***')
     +           slw20(ix,i)=amkreal(parse(10))
            if(parse(11)(1:3).ne.'---'.and.parse(11)(1:3).ne.'***')
     +           slczero(ix,i)=amkreal(parse(11))
            if(parse(12)(1:3).ne.'---'.and.parse(12)(1:3).ne.'***')
     +           slwzero(ix,i)=amkreal(parse(12))
C            if(parse(2)(1:3).ne.'---')then
C               write(iunit,'(''S'',i1,f7.0,x,f6.1,x,f8.0,
C     +              4(x,f6.1,x,f5.1))')i,slflux(ix,i),
C     +              slcpeak(ix,i),slpeak(ix,i),slc80(ix,i),
C     +              slw80(ix,i),slc50(ix,i),slw50(ix,i),slc20(ix,i),
C     +              slw20(ix,i),slczero(ix,i),slwzero(ix,i)
C            else
C               write(iunit,'(''S'',i1,4x,''---'',4x,''---'',6x,''---'',
C     +              4(4x,''---'',3x,''---''))')i
C            endif
         else if(parse(1)(1:1).eq.'E'.and.parse(1)(2:2).ne.'E')then
            i=mkint(parse(1)(2:3))
            if(parse(2)(1:3).ne.'---')then
               emflux(ix,i)=amkreal(parse(2))
               iemprof(ix,i)=1
            else
               emflux(ix,i)=-100.0
               iemprof(ix,i)=0
            endif
            if(parse(3)(1:3).ne.'---'.and.parse(3)(1:3).ne.'***')
     +           emcpeak(ix,i)=amkreal(parse(3))
            if(parse(4)(1:3).ne.'---'.and.parse(4)(1:3).ne.'***')
     +           empeak(ix,i)=amkreal(parse(4))
            if(parse(5)(1:3).ne.'---'.and.parse(5)(1:3).ne.'***')
     +           emc80(ix,i)=amkreal(parse(5))
            if(parse(6)(1:3).ne.'---'.and.parse(6)(1:3).ne.'***')
     +           emw80(ix,i)=amkreal(parse(6))
            if(parse(7)(1:3).ne.'---'.and.parse(7)(1:3).ne.'***')
     +           emc50(ix,i)=amkreal(parse(7))
            if(parse(8)(1:3).ne.'---'.and.parse(8)(1:3).ne.'***')
     +           emw50(ix,i)=amkreal(parse(8))
            if(parse(9)(1:3).ne.'---'.and.parse(9)(1:3).ne.'***')
     +           emc20(ix,i)=amkreal(parse(9))
            if(parse(10)(1:3).ne.'---'.and.parse(10)(1:3).ne.'***')
     +           emw20(ix,i)=amkreal(parse(10))
            if(parse(11)(1:3).ne.'---'.and.parse(11)(1:3).ne.'***')
     +           emczero(ix,i)=amkreal(parse(11))
            if(parse(12)(1:3).ne.'---'.and.parse(12)(1:3).ne.'***')
     +           emwzero(ix,i)=amkreal(parse(12))
C            if(parse(2)(1:3).ne.'---')then
C               write(iunit,'(''E'',i1,f7.0,x,f6.1,x,f8.0,
C     +              4(x,f6.1,x,f5.1))')i,emflux(ix,i),
C     +              emcpeak(ix,i),empeak(ix,i),emc80(ix,i),
C     +              emw80(ix,i),emc50(ix,i),emw50(ix,i),emc20(ix,i),
C     +              emw20(ix,i),emczero(ix,i),emwzero(ix,i)
C            else
C               write(iunit,'(''E'',i1,4x,''---'',4x,''---'',6x,''---'',
C     +              4(4x,''---'',3x,''---''))')i
C            endif
         else if(parse(1)(1:1).eq.'V'.and.parse(1)(2:2).ne.'E')then
            i=mkint(parse(1)(2:3))
            if(parse(2)(1:3).ne.'---'.and.parse(2)(1:3).ne.'***')then
               vpeak(ix,i)=amkreal(parse(2))
               ivprof(ix,i)=1
            else
               ivprof(ix,i)=0
            endif
            if(parse(5)(1:3).ne.'---'.and.parse(5)(1:3).ne.'***')
     +           v80(ix,i)=amkreal(parse(5))
            if(parse(6)(1:3).ne.'---'.and.parse(6)(1:3).ne.'***')
     +           w80(ix,i)=amkreal(parse(6))
            if(parse(7)(1:3).ne.'---'.and.parse(7)(1:3).ne.'***')
     +           v50(ix,i)=amkreal(parse(7))
            if(parse(8)(1:3).ne.'---'.and.parse(8)(1:3).ne.'***')
     +           w50(ix,i)=amkreal(parse(8))
            if(parse(9)(1:3).ne.'---'.and.parse(9)(1:3).ne.'***')
     +           v20(ix,i)=amkreal(parse(9))
            if(parse(10)(1:3).ne.'---'.and.parse(10)(1:3).ne.'***')
     +           w20(ix,i)=amkreal(parse(10))
            if(parse(11)(1:3).ne.'---'.and.parse(11)(1:3).ne.'***')
     +           vzero(ix,i)=amkreal(parse(11))
            if(parse(12)(1:3).ne.'---'.and.parse(12)(1:3).ne.'***')
     +           wzero(ix,i)=amkreal(parse(12))
C            if(parse(2)(1:3).ne.'---')then
C               
C               write(iunit,'(''V'',i1,8x,f6.1,9x,4(x,f6.1,x,f5.1))')
C     +              i,vpeak(ix,i),v80(ix,i),w80(ix,i),v50(ix,i),
C     +              w50(ix,i),v20(ix,i),w20(ix,i),vzero(ix,i),
C     +              wzero(ix,i)
c               
C            else
C               write(iunit,'(''V'',i1,11x,''---'',9x
c     +              4(4x,''---'',3x,''---''))')i
C               
C            endif
         endif
         read(1,'(a)') line
      enddo
      
      enddo

C      write(iunit,'(a)')line
C      write(*,'(''------------------------------------------'',
C     +     ''------------------------------------'')')
      goto 100
 200  close(1)
      nslice=ix-1
C      if(iunit.ne.6)close(2)

      call plotoptions(logfile)

      stop
      end

***********************************************************************

      subroutine plotoptions(logfile)

      common /zeropt/slzerox(100),slzeroy(100),isl1(100),isl2(100), 
     +     jsl1(100),jsl2(100),emzerox(100),emzeroy(100),iem1(100), 
     +     iem2(100), jem1(100),jem2(100),nslice
      common /centers/slc(100,9),sly(100,9),islcent(100,9),nslc(100),
     +     emc(100,9),emy(100,9),iemcent(100,9),nemc(100),
     +     dclambda(100,9),cvel(100,9),icvel(100,9)
      common /gaussians/slgcen(100,9),slgsig(100,9),slgamp(100,9),
     +     islgauss(100,9),emgcen(100,9),emgsig(100,9),emgamp(100,9),
     +     iemgauss(100,9),dglambda(100,9),gvel(100,9),igvel(100,9)
      common /profiles/slcpeak(100,9),slpeak(100,9),slc80(100,9),
     +     slw80(100,9),slc50(100,9),slw50(100,9),slc20(100,9),
     +     slw20(100,9),slczero(100,9),slwzero(100,9),slflux(100,9),
     +     islprof(100,9),emcpeak(100,9),empeak(100,9),emc80(100,9),
     +     emw80(100,9),emc50(100,9),emw50(100,9),emc20(100,9),
     +     emw20(100,9),emczero(100,9),emwzero(100,9),emflux(100,9),
     +     iemprof(100,9),vpeak(100,9),v80(100,9),w80(100,9),v50(100,9),
     +     w50(100,9),v20(100,9),w20(100,9),vzero(100,9),wzero(100,9),
     +     ivprof(100,9)

      common /radii/rad0(100,9),radl(100,9),radu(100,9),irad(100,9)
      common /spect/disp(100), lambda0(100)
      common /veloc/dlambda(100)

      COMMON/GRAPH/XMAX,XMIN,YMAX,YMIN,XTICK,YTICK,XSPACE,YSPACE
      common/plotlabels/xlab,ylab,title

      common/data/npoints,x(2000),xerru(2000),xerrl(2000),y(2000),
     +     yerru(2000),yerrl(2000),z(2000),zerru(2000),zerrl(2000),
     +     isym(2000),id(2000),ierr
      common/data2/qx(2000),qy(2000),qz(2000),psize(2000)
      common/zapa/izap(2000),qzap
      common/inoutput/inunit,icursor

      CHARACTER XLAB*60,YLAB*60,TITLE*60,options*20,aopt(2)*5
      character alab*50, logfile*50
      real noerr(2000,10),noq(2000,10),lambda0(100)

      integer iopt(2)

      inunit=5
      iorder=1
      jfit=3
      qmax=3
      qxmax=3
      qymax=3
      title=logfile

C     If no error bars or quality ratings in data file use these.
      do i=1,2000
         do j=1,10
            noerr(i,j)=0.0
            noq(i,j)=0.0
         enddo
      enddo

      npoints=0
      do i=1,nslice
         do j=1,nslc(i)
            npoints=npoints+1
         enddo
      enddo

      ierr=0
      ipopt=2
      nx=1
      ny=1

      write(*,'('' Enter Nx, Ny, plots per page (/='',i1,x,i1,
     +       ''): '',$)')nx,ny
      read*,nx,ny
      call pgbegin(0,'?',nx,ny)
      call pgscf(2)
      call pgask(.FALSE.)

      iopt(1)=4
      iopt(2)=4
      ioverplot=0

      do while(iopt(1).ne.0.and.iopt(2).ne.0)
         write(*,'(''X-Y axis options: '')')
         write(*,'(''  0: Quit.'')')
         write(*,'(''  1: Distance along slit from zero-point.'')')
         write(*,'(''  2: Mark Centers.'')')
         write(*,'(''  3: Gaussian Centers.'')')
         write(*,'(''  4: Profile Centers.'')')
         write(*,'(''  5: Slitless Spectrum Flux.'')')
         write(*,'(''  6: Emission Line Image Flux.'')')
         write(*,'('' 20: Change plot parameters.'')')
         write(*,'('' 21: Overplot next.'')')
         write(*,'(''Enter X-Y axis options: '',$)')
         read(*,'(a)')options

         call parser(options,' ',aopt,2,nback)
         iopt(1)=mkint(aopt(1))

         if(iopt(1).eq.20)then
            call pgend
            write(*,'('' Enter Nx, Ny, plots per page (/='',
     +           i1,x,i1,''): '',$)')nx,ny
            read*,nx,ny
            call pgbegin(0,'?',nx,ny)
            call pgscf(2)
            call pgask(.FALSE.)
         endif
         
         if(iopt(1).eq.21)ioverplot=1
         
         if(iopt(1).ne.0.and.iopt(1).lt.20)then
C            write(*,'('' Plot x, y, both or no error bars '',
C     +           ''(1, 2, 3 or 0; /='',i1,''): '',$)')ierr
C            read(*,*)ierr
            ierr=1
            iopt(2)=mkint(aopt(2))

            do iaxis=1,2

               if(iopt(iaxis).eq.1)then
                  alab='Radius (pixels)'
                  call axisload2d(iaxis,rad0,radl,radu,noq,
     +                 qmax,alab,irad,nslice,nslc)
               else if(iopt(iaxis).eq.2)then
                  alab='Cursor Marked Velocities (km/s)'
                  call axisload2d(iaxis,cvel,noerr,noerr,noq,qmax,
     +                 alab,icvel,nslice,nslc)
               else if(iopt(iaxis).eq.3)then
                  alab='Gaussian Fit Velocities (km/s)'
                  call axisload2d(iaxis,gvel,noerr,noerr,noq,qmax,
     +                 alab,igvel,nslice,nslc)
               else if(iopt(iaxis).eq.4)then
                  write(*,'('' Use Cpeak, C80, C50, C20, or Czero '',
     +                 ''(1,2,3,4,0; /='',i1,''): '',$)')ipopt
                  read(*,*)ipopt
                  alab='Profile Fit Velocities (km/s)'

                  if(ipopt.eq.1)then
                     call axisload2d(iaxis,vpeak,noerr,noerr,noq,
     +                    qmax,alab,ivprof,nslice,nslc)
                  else if(ipopt.eq.2)then
                     call axisload2d(iaxis,v80,noerr,noerr,noq,
     +                    qmax,alab,ivprof,nslice,nslc)
                  else if(ipopt.eq.3)then
                     call axisload2d(iaxis,v50,noerr,noerr,noq,
     +                    qmax,alab,ivprof,nslice,nslc)
                  else if(ipopt.eq.4)then
                     call axisload2d(iaxis,v20,noerr,noerr,noq,
     +                    qmax,alab,ivprof,nslice,nslc)
                  else if(ipopt.eq.0)then
                     call axisload2d(iaxis,vzero,noerr,noerr,noq,
     +                    qmax,alab,ivprof,nslice,nslc)
                  endif
               else if(iopt(iaxis).eq.5)then
                  alab='Profile Flux (Slitless - erg/s/cm\\u2\\d/\\A)'
                  call axisload2d(iaxis,slflux,noerr,noerr,noq,qmax,
     +                 alab,igvel,nslice,nslc)
               else if(iopt(iaxis).eq.6)then
                  alab='Profile Flux --- (Emis. Line Image - Counts)'
                  call axisload2d(iaxis,emflux,noerr,noerr,noq,qmax,
     +                 alab,igvel,nslice,nslc)
               endif
               if(iaxis.eq.1)call symload
            enddo

            if(ioverplot.eq.0)then
               write(*,'('' Enter plot boundaries (/='',4(x,
     +           f8.3),''): '',$)')xmin,xmax,ymin,ymax
               read*,xmin,xmax,ymin,ymax
               xspace=(xmax-xmin)/20.
               yspace=(ymax-ymin)/20.
            endif

            iunits=0
            if(iopt(1).eq.iopt(2)) iunits=1

            call plotpoints(iunits,0,ioverplot,qxmax,qymax)

            ioverplot=0
         endif
      enddo

      call pgend
      return
      end

*****************************************************************************
           
      subroutine parser(in,ch,parse,nout,nparse)
      character in*(*), ch*1, parse(*)*(*), work*80, work2*80

      nparse=0
      work=in
      nchar=80
      do while(nparse.lt.nout.and.nchar.gt.0)
         do while(work(1:1).eq.' '.and.nchar.gt.0)
            work2=work(2:80)
            work=work2
            nchar=nchar-1
         enddo
         i=1
         do while(work(i:i).ne.ch.and.nchar.gt.0)
            i=i+1
            nchar=nchar-1
         enddo
         if(i.gt.1)then
            nparse=nparse+1
            parse(nparse)=work(1:i-1)
            work2=work(i+1:80)
            work=work2
         endif
      enddo

      return
      end

      
*******************************************************************************

      function amkreal(in)
      character in*50
      read(in,*)x
      amkreal=x
      return
      end

*******************************************************************************

      function mkdouble(in)
      real*8 mkdouble,x
      character in*50
      read(in,*)x
      mkdouble=x
      return
      end

*******************************************************************************

      function mkint(in)
      character in*50
      read(in,*)i
      mkint=i
      return
      end

*******************************************************************************

      function istrlen(string, maxlen)

      character string*(*)
      
      j=0
      do i=1,maxlen
         if(string(i:i).eq.' ')then
            if(j.eq.0) j=i
         else
            j=0
         endif
      enddo
      istrlen=j-1
      return
      end

      

*****************************************************************************

      subroutine symload

      common/data/npoints,x(2000),xerru(2000),xerrl(2000),y(2000),
     +     yerru(2000),yerrl(2000),z(2000),zerru(2000),zerrl(2000),
     +     isym(2000),id(2000),ierr
      common/data2/qx(2000),qy(2000),qz(2000),psize(2000)
      common/zapa/izap(2000),qzap

      do i=1,npoints
         id(i)=i
         if(izap(i).le.0)then
            isym(i)=17
            psize(i)=2.0
         else if(izap(i).eq.2)then
            isym(i)=5
            psize(i)=2.0
         else
            isym(i)=0
            psize(i)=2.0
         endif
      enddo
      return
      end

*****************************************************************************

      subroutine axisload2d(iaxis,a,aerru,aerrl,aq,qmax,alab,ia,
     +     ni,nj)

C     For 2-D input array a(2000,10).

      COMMON/GRAPH/XMAX,XMIN,YMAX,YMIN,XTICK,YTICK,XSPACE,YSPACE
      common/plotlabels/xlab,ylab,title
      common/data/npoints,x(2000),xerru(2000),xerrl(2000),y(2000),
     +     yerru(2000),yerrl(2000),z(2000),zerru(2000),zerrl(2000),
     +     isym(2000),id(2000),ierr
      common/data2/qx(2000),qy(2000),qz(2000),psize(2000)
      common/zapa/izap(2000),qzap

      CHARACTER*60 XLAB,YLAB,TITLE
C      real a(m1,m2),aerrl(m1,m2),aerru(m1,m2),aq(m1,m2)
C      integer ia(m1,m2),nj(m1)
      real a(100,9),aerrl(100,9),aerru(100,9),aq(100,9)
      integer ia(100,9),nj(100)
      character alab*50
      
      if(iaxis.eq.1)then
         xmax=-1E20
         xmin=1E20
         xlab=alab
         k=0
         
         do i=1,ni
            do j=1,nj(i)
               k=k+1
               x(k)=a(i,j)
               xerrl(k)=x(k)-aerrl(i,j)
               xerru(k)=x(k)+aerru(i,j)
               qx(k)=aq(i,j) 

               if(ia(i,j).eq.0.and.izap(k).ne.1)then
                  izap(k)=1
               endif
C               print*,a(i,j),ia(i,j),k,x(k),xerrl(k),xerru(k),
C     +              qx(k),izap(k)
               if(ierr.eq.1.or.ierr.eq.3)then
                  if((aq(i,j).le.qmax).or.(qmax.eq.0.0))then
                     if(izap(k).ne.1)then
                        xmax=max(xmax,xerru(k))
                        xmin=min(xmin,xerrl(k))
                     endif
                  endif
               else
                  if((aq(i,j).le.qmax).or.(qmax.eq.0.0))then
                     if(izap(k).ne.1)then
                        xmax=max(xmax,x(k))
                        xmin=min(xmin,x(k))
                     endif
                  endif
               endif
            enddo
         enddo

         xspace=(xmax-xmin)/20.
         if(xspace.eq.0.0)xspace=0.1
         if(ierr.eq.1.or.ierr.eq.3)then
            xmin=xmin-xspace
            xmax=xmax+xspace
         else
            xmin=xmin-2.*xspace
            xmax=xmax+2.*xspace
         endif

      else if(iaxis.eq.2)then
         ymax=-1E20
         ymin=1E20
         ylab=alab
         k=0
         do i=1,ni
            do j=1,nj(i)
               k=k+1
               y(k)=a(i,j)
               yerrl(k)=y(k)-aerrl(i,j)
               yerru(k)=y(k)+aerru(i,j)
               qy(k)=aq(i,j)
               if(ia(i,j).eq.0.and.izap(k).ne.1)then
                  izap(k)=1
               endif

C               print*,a(i,j),ia(i,j),k,y(k),yerrl(k),yerru(k),
C     +              qy(k),izap(k)
               if(ierr.eq.2.or.ierr.eq.3)then
                  if((aq(i,j).le.qmax).or.(qmax.eq.0.0))then
                     if(izap(k).ne.1)then
                        ymax=max(ymax,yerru(k))
                        ymin=min(ymin,yerrl(k))
                     endif
                  endif
               else
                  if((aq(i,j).le.qmax).or.(qmax.eq.0.0))then
                     if(izap(k).ne.1)then
                        ymax=max(ymax,y(k))
                        ymin=min(ymin,y(k))
                     endif
                  endif
               endif
            enddo
         enddo
         yspace=(ymax-ymin)/20.
         if(yspace.eq.0.0)yspace=0.1

         if(ierr.eq.2.or.ierr.eq.3)then
            ymin=ymin-yspace
            ymax=ymax+yspace
         else
            ymin=ymin-2.*yspace
            ymax=ymax+2.*yspace
         endif
      endif

      return
      end

*****************************************************************************

	SUBROUTINE PLOTPOINTS(iunits,idplot,iover,qxmax,qymax)

	COMMON/GRAPH/XMAX,XMIN,YMAX,YMIN,XTICK,YTICK,XSPACE,YSPACE
        common/plotlabels/xlab,ylab,title
        common/data/npoints,x(2000),xerru(2000),xerrl(2000),y(2000),
     +     yerru(2000),yerrl(2000),z(2000),zerru(2000),zerrl(2000),
     +     isym(2000),id(2000),ierr
        common/data2/qx(2000),qy(2000),qz(2000),psize(2000)
        common/zapa/izap(2000),qzap
        common/inoutput/inunit,icursor
	CHARACTER*60 XLAB,YLAB,TITLE

        common/fitplot/smax,smin

        ytick=10.**(nint(log10(abs(ymax-ymin))-1.))
        nysub=5
        ntick=int(abs(ymax-ymin)/ytick)
        if(ntick.ge.15)then
           ytick=ytick*5.
        else if(ntick.gt.6.and.ntick.lt.15)then
           ytick=ytick*2.
           nysub=4
        else if(ntick.lt.3)then
           ytick=ytick/2.
           nysub=5
        endif

        xtick=10.**(nint(log10(abs(xmax-xmin))-1.))
        nxsub=5
        ntick=int(abs(xmax-xmin)/xtick)
        if(ntick.ge.15)then
           xtick=xtick*5.
        else if(ntick.gt.6.and.ntick.lt.15)then
           xtick=xtick*2.
           nxsub=4
        else if(ntick.lt.3)then
           xtick=xtick/2.
           nxsub=5
        endif

        if(iover.eq.0)then
           CALL PGADVANCE
           call pgsch(1.3)
           call pgqci(ici)
           call pgsci(7)
           units=0
           CALL PGVPORT(0.12,0.95,0.12,0.95)
           if(iunits.eq.0)then
              CALL PGWINDOW(XMIN,XMAX,YMIN,YMAX)
           else
              call pgwnad(XMIN,XMAX,YMIN,YMAX)
           endif
           CALL PGSLW(3)
           CALL PGBOX('BCTS',XTICK,nxsub,'BCTS',YTICK,nysub)
           CALL PGSLW(2)
           CALL PGBOX('N',XTICK,nxsub,'N',YTICK,nysub)
           call pgslw(2)
           call pgsci(3)
           CALL PGMTXT('B',2.4,0.5,0.5,XLAB)
           CALL PGMTXT('L',2.2,0.5,0.5,YLAB)
           if(title.ne.' ') CALL PGMTXT('T',0.5,0.5,0.5,title)
           call pgsci(ici)
        endif

        call pgsch(2.0)
        print*,' Plotting points ...'
        if(idplot.eq.0)then
           call pgslw(5)
           do i=1,npoints
              if(psize(i).ne.0.0) call pgsch(psize(i))
              if(((qx(i).le.qxmax.and.qy(i).le.qymax).or.
     +        (qxmax.eq.0.and.qymax.eq.0)).and.izap(i).ne.1)then
                 call pgpt(1,x(i),y(i),isym(i))
C                 print*,i,x(i),xerru(i),y(i),yerru(i)
                 print*,i,x(i),y(i)

                 if(ierr.eq.1.or.ierr.eq.3)then
                    call pgslw(2)
                    call pgerrx(1,xerrl(i),xerru(i),y(i),0.5)
                    call pgslw(5)
                 endif
                 if(ierr.eq.2.or.ierr.eq.3)then
                    call pgslw(2)
                    call pgerry(1,x(i),yerrl(i),yerru(i),0.5)
                    call pgslw(5)
                 endif
              endif
           enddo
        endif
        call pgsch(2.0)
        call pgslw(2)

        if(smin.ne.smax)then
           call pgerrx(1,smin,smax,ymin+1.5*yspace,1.2) 
        endif

	RETURN
	END


******************************************************************************

      function erraxis(ierr,iaxis)

C     If the parameter being plotted has no error bars, check that the
C     value of ierr is consistent.

      erraxis=ierr
      if(iaxis.eq.1)then
         if(ierr.eq.1)erraxis=0
         if(ierr.eq.3)erraxis=2
      else if(iaxis.eq.2)then
         if(ierr.eq.2)erraxis=0
         if(ierr.eq.3)erraxis=1
      else 
         erraxis=ierr
      endif
      return
      end

******************************************************************************
